unit Tsmi;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus;

type
  TSpecialMenuItem = class(TmenuItem)
  public
    procedure Click;  override;
  end;

  TAddSpecialMenu = class(TComponent)
  public
    SpecialMenuItem: TSpecialMenuItem;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;


procedure Register;

implementation


constructor TAddSpecialMenu.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  SpecialMenuItem:= Nil;
  if not (AOwner is TForm) then
    Exit;
  if TForm(AOwner).Menu = Nil then
    Exit;
  SpecialMenuItem:= TSpecialMenuItem.Create(AOwner);
  SpecialMenuItem.Name:= 'SMIN';
  SpecialMenuItem.Caption:= 'Special';
  TForm(AOwner).Menu.Items.Add(SpecialMenuItem);
end;

destructor TAddSpecialMenu.Destroy;
var Idx: integer;
begin
  if SpecialMenuItem <> Nil then
    if not (csDestroying in SpecialMenuItem.ComponentState) then
      SpecialMenuItem.Free;
  inherited Destroy;
end;

procedure TSpecialMenuItem.Click;
begin
   ShowMessage('Put your customized code in here');
end;


procedure Register;
begin
  RegisterComponents('Sample', [TAddSpecialMenu]);
  RegisterComponents('Sample', [TSpecialMenuItem]);
end;

end.
